% External file

function x=gengau2(alpha,m,n)
%from BSSGUI by J. Petkov by Jakub Petkov
%
% Generates random variables with generalized
% Gaussian distribution with parameter alpha > 0
%                 and variance 1.
% The generator is only approximate,
%  the generated r.v. are bounded by 1000.
%
% Method: numerical inversion of the distribution function
%         at points uniformly distributed in [0,1];
%
r=0.5*rand(1,m*n)+0.5;    %%% distribution is symmetric ...
                          %%% it is enough to consider r>0.5
beta=sqrt(gamma(3/alpha)/gamma(1/alpha));
y=r/beta;
ymin=1e-20*ones(1,m*n); ymax=1000*ones(1,m*n);
%                           for simplicity, generated r.v. are bounded by 1000.
for iter=1:33
    cdf=0.5+0.5*gammainc((beta*y).^alpha,1/alpha);
    indplus=find(cdf>r);
    if any(indplus)
       ymax(indplus)=y(indplus);
    end
    indminus=find(cdf<r);
    if any(indminus)
       ymin(indminus)=y(indminus);
    end   
    y=0.5*(ymax+ymin);
end    
ind=rand(1,m*n)>0.5;
if any(ind)
   y(ind)=-y(ind);
end   
x=reshape(y,m,n);


